#include"stdio.h"
#include"stdlib.h"
#include"string.h"

#include"satwrite.h"

typedef  char      line_data[72];
typedef  line_data two_line[2];

two_line     sat_data[2];
char         catnr[255],elset[255];

// copia il double in una stringa, con totn car(prima della virgola)
// e dec caratteri (dopo la virgola) il tutto va nella stringa str
void Str(double num, int totn, int dec,char str[])
{
char   str1[15],str2[15];
double aus1,aus2;
int    i,j;

   aus1=Trunc(num);
   aus2=(num-aus1)*1000000000;
   ltoa(((long)aus1), str1, 10);
   if (aus2<0) aus2=-aus2;
   ltoa(((long)aus2), str2, 10);
   j=strlen(str2);
   for (i=1;i<=totn-strlen(str1);i++) str[i-1]=' ';
   str[i-1]='\0';
   strcat(str,str1);
   if (dec==0) strcat(str,"\0");
   else {
      strcat(str,".\0");
      strcat(str,str2);
      str[strlen(str)-j+dec]='\0';
   }
}


//copia da ini per cont caratteri la stringa str[] in *s
void   Copy(char str[],int ini,int cont,char *s)
{
int  i;
char k[]="\0\0";

 strcpy(s,"\0");
 for (i=ini;i<ini+cont;i++) {
      if (str[i-1]=='\0') break;
      k[0]=str[i-1];
      strcat(s,k);
 }
 strcat(s,"\0");
}

//restituisce un int della stringa buffer[] partendo da start per lenght caratteri
int Integer_Value(char buffer[],int start,int length)
{
char str[8];

 Copy(buffer,start,length,str);

return(atoi(str));
}

//restituisce un double della stringa buffer[] partendo da start per lenght caratteri
double Real_Value(char buffer[],int start,int length)
{
int    result;
double answer;
char   str[17];

 Copy(buffer,start,length,str);
 return (atof(str));
}//  end; {Function Real_Value}

//converte numeri <999 in stringhe
void ThreeDigit(int arg, char *string)
{
char str[4];

 if (arg<10)       strcpy(string,"  ");
 else if (arg<100) strcpy(string, " ");
 itoa(arg,str,10);
 strcat(string,str);
}

//converte numeri <99 in stringhe
void TwoDigit(int arg,char *string)
{
char str[4];

 if (arg<10)       strcpy(string,"  ");
 itoa(arg,str,10);
 strcat(string,str);
}

//converte i file 2LE in formato leggibile dal programma AlfaSim
void Convert_Satellite_Data(int arg)
{
int     iexp,ibexp;
double  a1,ao,del1,delo,xnodp,temp;
char    abuf[2][255];

  strcpy(abuf[0],sat_data[arg][0]);
  strcpy(abuf[1],sat_data[arg][1]);
//{* Decode Card 2 *}
  Copy(abuf[1],3,5,catnr);
  epoch     = Real_Value(abuf[0],19,14);
  julian_epoch = Julian_Date_of_Epoch(epoch);
  xndt2o    = Real_Value(abuf[0],34,10);
  xndd6o    = Real_Value(abuf[0],45,6)*1E-5;
  iexp      = Integer_Value(abuf[0],51,2);
  bstar     = Real_Value(abuf[0],54,6)*1E-5;
  ibexp     = Integer_Value(abuf[0],60,2);
  ThreeDigit(Integer_Value(abuf[0],66,3),elset);
//{* Decode Card 2 *}
  xincl     = Real_Value(abuf[1],9,8);
  xnodeo    = Real_Value(abuf[1],18,8);
  eo        = Real_Value(abuf[1],27,7)*1E-7;
  omegao    = Real_Value(abuf[1],35,8);
  xmo       = Real_Value(abuf[1],44,8);
  xno       = Real_Value(abuf[1],53,11);
//{ period    = 1/xno; }
//{* Convert to proper units *}
  xndd6o    = xndd6o*Power(10.0,iexp);
  bstar     = bstar*Power(10.0,ibexp)/ae;
  xnodeo    = GtoR(xnodeo);
  omegao    = GtoR(omegao);
  xmo       = GtoR(xmo);
  xincl     = GtoR(xincl);
  xno       = xno*twopi/xmnpda;
  xndt2o    = xndt2o*twopi/(xmnpda*xmnpda);
  xndd6o    = xndd6o*twopi/Cube(xmnpda);
//{* Determine whether Deep-Space Model is needed *}
  a1        = Power(xke/xno,tothrd);
  temp      = 1.5*ck2*(3*cos(xincl)*cos(xincl)-1)/Power(1 - eo*eo,1.5);
  del1      = temp/(a1*a1);
  ao        = a1*(1 - del1*(0.5*tothrd + del1*(1 + 134/81*del1)));
  delo      = temp/(ao*ao);
  xnodp     = xno/(1 + delo);
  if (twopi/xnodp >= 225)     ideep = 1;
  else                        ideep = 0;
  iflag = 1;
}

// Converte i Risultati moltiplicando per il raggio della Terra
void Convert_Sat_State1(MATRIX Pos,MATRIX Vel)
{
int i;

  for (i=0;i<=2;i++) {
       Pos[i][0] = Pos[i][0]*xkmper;    //{kilometers}
       Vel[i][0] = Vel[i][0]*xkmper/60; //{kilometers/second}
  }
}

//INIZIALIZZAZIONE PROGRAMMA
void Program_Init(void)
{
//inizializzazione fondamentale
  civil        = GtoR(-6);
  nautical     = GtoR(-12);
  astronomical = GtoR(-18);

  Define_Derived_Constants();

}

//TERMINE PROGRAMMA
void Program_End(void)
{
}







